#pragma once

#include <ds-model/installation-fwd.h>
#include <ds/asio/resource-fwd.h>
#include <model/apartment.h>

namespace dsApartment {

class Installation : boost::noncopyable {
public:
  virtual ~Installation() = default;

  virtual dsModel::Floor floor(const dsModel::FloorId &) const = 0;
  virtual dsModel::Floors floors() const = 0;
  virtual void setFloorName(const dsModel::FloorId &, const std::string &value) = 0;
  virtual dsModel::Installation installation() const = 0;
  virtual dsModel::DSServer dsServer() const = 0;
  virtual dsModel::Controller controller(const dsModel::ControllerId &) const = 0;
  virtual dsModel::AuthorizeControllerResult authorizeController(const dsModel::ControllerId &id,
                                                                 dsModel::AuthorizeControllerArgs &&args) = 0;
  virtual void storeControllerAccessToken(const dsModel::ControllerId &,
                                          dsModel::StoreControllerAccessTokenArgs &&) = 0;
  virtual dsModel::Controllers controllers() const = 0;
};

std::unique_ptr<Installation> makeInstallation(ds::asio::ResourceBase &, dss::Apartment &, dsApi::AsyncCallee &bus);

} // namespace dsApartment
