// Generated file.  DO NOT EDIT!
// source: open-metering-system.yaml

// clang-format off

#pragma once


/// Open-metering-system
///
/// https://en.wikipedia.org/wiki/Open_metering_system
///
/// ```json
/// GET /installation/open-metering-system/meterings
/// {
///   "data:{
///     {"id":"actual-electricity-power-delivered"}
///     {"id":"actual-electricity-power-received"}
///     {"id":"meter-reading-electricity-energy-delivered-to-client-tariff1"}
///     {"id":"meter-reading-electricity-energy-delivered-to-client-tariff2"}
///     {"id":"meter-reading-electricity-energy-delivered-by-client-tariff1"}
///     {"id":"meter-reading-electricity-energy-delivered-by-client-tariff2"}
///   }
/// }
/// GET /installation/open-metering-system/actual-electricity-power-delivered
/// {
///   "data":{
///     "id":"actual-electricity-power-delivered","type":"electricityPowerConsumed"
///     "unit":"W","technicalName": "P1 1-0:1.7.0.255","origin":{"type":"open metering system","id":"makeup dsuid or e/a"}
///   }
/// }
/// ```
///
/// ### Collection of metering values
///
/// Metering value id matches 1:1 to metering id
///
/// ```json
/// GET /installation/open-metering-system/values
/// {
///   "data":{
///     "values":{
///       {"id":"actual-electricity-power-delivered","type":"meteringValue","lastChanged":"...", "attributes":{"values":11.2}},
///       {"id":"actual-electricity-power-received", "type":"meteringValue","lastCahnged":"...", "attributes":{"values":17.0}},
///       {"id":"meter-reading-electricity-energy-delivered-to-client-tariff1","type":"meteringValue","lastChanged":"...", "attributes":{"values":18.2}}
///       {"id":"meter-reading-electricity-energy-delivered-to-client-tariff2","type":"meteringValue","lastChanged":"...", "attributes":{"values":14.8}}
///       {"id":"meter-reading-electricity-energy-delivered-by-client-tariff1","type":"meteringValue","lastChanged":"...", "attributes":{"values":8.3}}
///       {"id":"meter-reading-electricity-energy-delivered-by-client-tariff2","type":"meteringValue","lastChanged":"...", "attributes":{"values":0.2}}
///     }
///   }
/// }
/// ```
///
/// ```json
/// GET /installation/open-metering-system/values/metering-reading-electricity-energy-delivered-by-client-tariff1
/// {
///   "data":{
///     "id":"metering-reading-electricity-energy-delivered-by-client-tariff1","type":"meteringValue","lastChanged":"...","attributes":{"value":11.2}
///   }
/// }
/// ```
///
/// ### Metering values event
///
/// Metering values event is sent when some client is subscribed to 'openMeteringSystemValues' event type.
///
/// ```json
/// event:{
///   "type":"opentMeteringSystemValues"
///   "data":{
///     "values":[
///       {"id":"actual-electricity-power-delivered","type":"meteringValue","lastChanged":"...", "attributes":{"values":11.2}},
///       {"id":"actual-electricity-power-received", "type":"meteringValue","lastCahnged":"...", "attributes":{"values":17.0}},
///       {"id":"meter-reading-electricity-energy-delivered-to-client-tariff1","type":"meteringValue","lastChanged":"...", "attributes":{"values":18.2}}
///       {"id":"meter-reading-electricity-energy-delivered-to-client-tariff2","type":"meteringValue","lastChanged":"...", "attributes":{"values":14.8}}
///       {"id":"meter-reading-electricity-energy-delivered-by-client-tariff1","type":"meteringValue","lastChanged":"...", "attributes":{"values":8.3}}
///       {"id":"meter-reading-electricity-energy-delivered-by-client-tariff2","type":"meteringValue","lastChanged":"...", "attributes":{"values":0.2}}
///     ]
///   }
/// }
/// ```

#include "open-metering-system-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "common.h"
#include "model-fwd.h"

#include <ds/json.h>


/// Example: meter-reading-electricity-energy-delivered-to-client-tariff2
DS_REFLECTED_ENUM((dsModel), OpenMeteringSystemId,
    (none)
    (electricityPowerConsumed)
    (electricityPowerProduced)
    (electricityEnergyConsumedTariff1)
    (electricityEnergyConsumedTariff2)
    (electricityEnergyProducedTariff1)
    (electricityEnergyProducedTariff2)
);


/// Example: electricityEnergyConsumed
DS_REFLECTED_ENUM((dsModel), OpenMeteringSystemType,
    (none)
    (electricityPowerConsumed)
    (electricityPowerProduced)
    (electricityEnergyConsumed)
    (electricityEnergyProduced)
);

namespace dsModel {
struct OpenMeteringSystemOrigin {
  std::string type = "p1";

  ~OpenMeteringSystemOrigin();
};

struct OpenMeteringSystemMeteringAttributes {
  std::string unit{};
  std::string technicalName{};
  OpenMeteringSystemOrigin origin{};

  ~OpenMeteringSystemMeteringAttributes();
};

struct OpenMeteringSystemMetering {
  OpenMeteringSystemId id{};
  OpenMeteringSystemType type{};
  ds::DateTime lastChanged{};
  OpenMeteringSystemMeteringAttributes attributes{};

  ~OpenMeteringSystemMetering();
};

struct OpenMeteringSystemMeterings {
  std::vector<OpenMeteringSystemMetering> meterings{};

  ~OpenMeteringSystemMeterings();
};

struct OpenMeteringSystemValueAttributes {
  std::optional<double> value{};

  ~OpenMeteringSystemValueAttributes();
};

struct OpenMeteringSystemValue {
  OpenMeteringSystemId id{};
  std::string type = "meteringValue";
  ds::DateTime lastChanged{};
  OpenMeteringSystemValueAttributes attributes{};

  ~OpenMeteringSystemValue();
};

struct OpenMeteringSystemValues {
  std::vector<OpenMeteringSystemValue> values{};

  ~OpenMeteringSystemValues();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemOrigin,
    (type)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemMeteringAttributes,
    (unit)
    (technicalName)
    (origin)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemMetering,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemMeterings,
    (meterings)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemValueAttributes,
    (value)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemValue,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), OpenMeteringSystemValues,
    (values)
);

