/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>

#include "metering/archives.h"
#include "metering/metering.h"

namespace dss {

class MeteringMock : public trompeloeil::mock_interface<Metering> {
public:
  IMPLEMENT_CONST_MOCK0(getConfig);
  IMPLEMENT_CONST_MOCK1(recreateDeadArchives);
  IMPLEMENT_CONST_MOCK1(getEnergy);
  IMPLEMENT_CONST_MOCK1(getConsumedPower);
  IMPLEMENT_CONST_MOCK1(getProducedPower);
  IMPLEMENT_CONST_MOCK0(getConsumedPowerApartment);
  IMPLEMENT_CONST_MOCK0(getProducedPowerApartment);
  IMPLEMENT_CONST_MOCK1(getLastEnergy);
  IMPLEMENT_CONST_MOCK1(getProducedEnergy);
  IMPLEMENT_CONST_MOCK0(searchArchivesInFolder);
  IMPLEMENT_MOCK2(createState);
  IMPLEMENT_MOCK2(removeState);
  IMPLEMENT_MOCK2(triggerState);
  IMPLEMENT_MOCK1(setMeteringBusInterface);
  IMPLEMENT_MOCK1(validateAndConvertArchive);
  IMPLEMENT_MOCK2(addConsumedEnergy);
  IMPLEMENT_MOCK2(addProducedEnergy);
  IMPLEMENT_MOCK2(get15minConsumed);
  IMPLEMENT_MOCK2(get15minProduced);
  IMPLEMENT_MOCK6(getSeries);
  IMPLEMENT_MOCK6(getProducedSeries);

  // integration tests (dsstests)
  IMPLEMENT_MOCK0(getArchives);
  IMPLEMENT_MOCK0(checkDBConsistency);
};

} // namespace dss
