/*
    Copyright (c) 2022 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <boost/asio/io_context.hpp>

#include "metering-fwd.h"

namespace dss::metering {

class SocketServer {
public:
  virtual ~SocketServer() = default;
  virtual void start() = 0;
};

std::unique_ptr<SocketServer> makeSocketServer(boost::asio::io_context& io, const std::string& socketPath,
                                               Metering& metering);

} // namespace dss::metering
